<?php
/*
* Simmple as door gallery Script
* Requires PHP installation and GD library.
*
* This version of the script was created for the sole reason to provide "quick'n'dirty"
* image gallery functionality the easiest possible way.
*
* @version 0.1
* @author Baglan Dosmagambetov <baglan@ankara.edu.tr>
* @copyright 2004, Baglan Dosmagambeov
*
* (!!!) Some modifications, for making this script more universal and adding some settings 
* Graf theXnews.com, 2008
*/

//SETTINGS SETTINGS SETTINGS

define('WIDTH',200);				// Thumbmail image width
define('HEIGHT',200);				// Thumbnail image height
define('EXT','.tmb');				// Thumbnail extension
define('IMAGES_PER_PAGE',16);			// Image count per one page
define('IMAGES_PER_ROW',4);			// Image count per one row

//RGB for thumbinal background
define('R',255);
define('G',255);
define('B',255);

//SETTINGS SETTINGS SETTINGS

  // This stuff we make, for normal include()  --Graf
  $parentdir=getcwd();
  chdir(dirname(__FILE__));
  $popravka=".".str_replace($parentdir,"",getcwd())."/";
  
  $snbreak = Explode('/', $_SERVER["SCRIPT_NAME"]);
  $scriptname = $snbreak[count($snbreak) - 1]; 

  parse_str($_SERVER['QUERY_STRING']);


if ( $act=='thumb' )
{
  // Intialize frequently used request parameters
  $file = $_REQUEST['file'];
  $thumb = $_REQUEST['file'].EXT;

  //Check if a thumbnail with a newer timestamp exists.
  //If exists, spool the thumbnail

  if ( (file_exists($thumb)) && (filemtime($thumb)>=filemtime($file)) )
  {
    header('Content-type: image/jpeg');
    $size = filesize($_REQUEST['file'].EXT);
    $fd = fopen($_REQUEST['file'].EXT,'rb');
    echo fread( $fd, $size );
    fclose( $fd );
    exit();
  }

  // Thumbnail doesn't exist
  // a. Make sure that file exists and that it's of supported format
  // b. Create and spool the thumbnail
  // c. Save created thumbnail 

  $imageInfo = getimagesize( $file );
  switch( $imageInfo[2] )
  {
    case 1: $image = imagecreatefromgif( $file ); break;
    case 2: $image = imagecreatefromjpeg( $file ); break;
    case 3: $image = imagecreatefrompng( $file ); break;
    default: exit();
  }

  // Create the thumnail image
  $result = imagecreatetruecolor(WIDTH,HEIGHT);
  $bg = imagecolorallocate( $result, R, G, B );
  imagefilledrectangle( $result, 0, 0, WIDTH-1, HEIGHT-1, $bg );

  // Calculate the aspect ratio for the thumbnail
  $ratio1 = $imageInfo[0]/WIDTH;
  $ratio2 = $imageInfo[1]/HEIGHT;
  $ratio = $ratio1>$ratio2?$ratio1:$ratio2;
  if ( $ratio<1 )
          $ratio=1;
  $width = $imageInfo[0]/$ratio;
  $height = $imageInfo[1]/$ratio;
  imagecopyresampled( $result, $image, (WIDTH-$width)/2, (HEIGHT-$height)/2, 0, 0, $width, $height, $imageInfo[0], $imageInfo[1]);

  // Spool thumbnail image
  header('Content-type: image/jpeg');
  imagejpeg($result);

  // Save the thumbnail image so that if requested again,thumbnail will not have to be generated
  imagejpeg($result,$thumb);

  // End program here
  exit();
}


// Get supported image types.
// Read-only GIF support somehow is not returned, see if corresponding function exists

$supported = imagetypes();
if ( function_exists('imagecreatefromgif') ) {$supported |= IMG_GIF;}

$files = array();
$thumbs = array();

$dir = opendir('.');
while( ($file=readdir( $dir ))!==false )
{
  // Skip if not a file
  if ( !is_file($file) ) continue;
		
  $ext = strrchr($file, '.');
  $extLower = strtolower($ext);
  if (
    $extLower=='.gif' && ($supported & IMG_GIF)
    || $extLower=='.png' && ($supported & IMG_PNG)
    || $extLower=='.jpeg' && ($supported & IMG_JPG)
    || $extLower=='.jpg' && ($supported & IMG_JPG)
  )
    {$files[] = $file;}
  else if ( $ext==EXT )
    {$thumbs[] = $file;}
}
closedir($dir);

if (($act=='list')or(!$act))
{
  echo "<div class='gallery_content'>";

  $ipp=IMAGES_PER_PAGE;
  if ($skip<1) {$from=1;} else {$from=$skip;}
  $to=$from+$ipp-1;
  if ($to>count($files)) {$to=count($files)-1;}
  $j=0;

  for ($i=$from;$i<=$to;$i++)
    {
    $file=$files[$i];

    if ($j==IMAGES_PER_ROW) {echo "<br/>"; $j=1;}
    else {$j++;}

    $title = $file;
    


    echo "<a href='?act=view&pic=$file'><img src='".$popravka.$scriptname."?act=thumb&file=$file' alt='$title'></a>";
    }


  // Here, we trying to display navigation  --Graf
  
  echo "</div><div class='gallery_navigation'>";

  if ($from>1) {echo '<a href="?act=list&skip=',$from-$ipp,'">&larr; Prev</a>';}

  $k=1;
  for ($j=1; $j <= count($files); $j=$j+$ipp) 
    {
    if ($j==$from) {echo '<a class="gallery_button_current">',$k,"</a>";}
      else {echo "<a href='?act=list&skip=$j'>$k</a>";}
    $k++;
    }

  if ($to+$ipp<count($files)+2) {echo "<a href='?act=list&skip=",$to+1,"'>Next &rarr;</a>";}

  echo "<!-- Showing from $from to $to of ",count($files)," images. -->";
  echo "<!-- aerwe6yf464645d536c -->";

  echo "</div>";


  // Remove thumbs not associated with image files
  $extLength = strlen( EXT );
  foreach( $thumbs as $thumb )
  {
    $file = substr( $thumb, 0, strlen($thumb)-$extLength );
    if ( !file_exists($file) ) {unlink($thumb);}
  }
  
}

if ($act=='view') 
{
  echo "<div class='gallery_content'>";

  echo "<img src='".$popravka.$pic."'>";

  echo "</div><div class='gallery_navigation'>";

  $no=array_search($pic,$files);
  echo "<a href='?act=view&pic=".$files[$no-1]."'>&larr Prev</a>";
  echo "<a href='?act=list&skip=".$no."'>List View</a>";
  echo "<a href='?act=view&pic=".$files[$no+1]."'>Next &rarr</a>";

  echo "</div>";
}

chdir($parentdir);
?>
